unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, DBCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ImageList1: TImageList;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
  private
    procedure OnValidateNonNegNumber(Sender: TField);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bufdataset1.FileName := 'test.db';
  if not FileExists(Bufdataset1.FileName) then
  begin
    BufDataset1.FieldDefs.Add('x', ftFloat);
    BufDataset1.FieldDefs.Add('y', ftFloat);
    BufDataset1.CreateDataset;

    Bufdataset1.Append;
    BufDataset1.FieldByName('x').AsFloat := 0.12;
    BufDataset1.FieldByName('y').AsFloat := 0.36;
    BufDataset1.Post;

    Bufdataset1.Append;
    BufDataset1.FieldByName('x').AsFloat := 0.21;
    BufDataset1.FieldByName('y').AsFloat := 0.19;
    BufDataset1.Post;
  end;
  BufDataset1.Open;
  (BufDataset1.FieldByName('x') as TFloatField).DisplayFormat := '0.000';
  (BufDataset1.FieldByName('y') as TFloatField).DisplayFormat := '0.000';
end;

procedure TForm1.RadioButton1Change(Sender: TObject);
begin
  if RadioButton1.Checked then
    DBNavigator1.Images := nil
  else
    DBNavigator1.Images := ImageList1;
end;

procedure TForm1.OnValidateNonNegNumber(Sender: TField);
begin
end;

end.

